diff --git a/lib/hive/daemon/logger.rb b/lib/hive/daemon/logger.rb
index 6af59dc9..afc20cf0 100644
--- a/lib/hive/daemon/logger.rb
+++ b/lib/hive/daemon/logger.rb
@@ -50,6 +50,9 @@ module Hive
         marker_heal_failed
         marker_heal_exhausted
         marker_heal_observer_missing
+        auto_retry_decision
+        auto_retry_action
+        auto_retry_error
         display_name_backfill
         update_available
         update_check_no_result
diff --git a/lib/hive/daemon/status_consumer.rb b/lib/hive/daemon/status_consumer.rb
index b483ad0a..48c28a2d 100644
--- a/lib/hive/daemon/status_consumer.rb
+++ b/lib/hive/daemon/status_consumer.rb
@@ -16,7 +16,7 @@ module Hive
       # the runner has written its claude_pid to the lock. The daemon
       # healer and dispatcher both need this so they don't race the runner
       # during the pre-claude window (issue #144).
-      Row = Struct.new(:project, :slug, :stage, :workflow, :marker, :marker_attrs, :folder, :state_file,
+      Row = Struct.new(:project, :id, :slug, :stage, :workflow, :marker, :marker_attrs, :folder, :state_file,
                        :state_file_mtime, :action, :suggested_command, :claude_pid_alive,
                        :live_task_lock, :diagnostic, :depends_on, :blocked_by,
                        :dependency_stage, :blocked,
@@ -180,6 +180,7 @@ module Hive
           Array(project_doc["tasks"]).each do |task|
             rows << Row.new(
               project: project,
+              id: task["id"],
               slug: task["slug"],
               stage: task["stage"],
               workflow: task["workflow"],
diff --git a/lib/hive/events.rb b/lib/hive/events.rb
index f8bca816..42cad8f9 100644
--- a/lib/hive/events.rb
+++ b/lib/hive/events.rb
@@ -15,6 +15,9 @@ module Hive
       round_complete
       clean_exit_auto_committed
       claude_completion_fallback
+      auto_retry_decision
+      auto_retry_reserved
+      marker_cleared
     ].freeze
 
     STATUS_TAIL_LINES = 20
@@ -32,6 +35,7 @@ module Hive
     # Keeps the full JSON line well below the single-write append budget
     # so concurrent emitters cannot interleave bytes within a record.
     MAX_MESSAGE_BYTES = 1024
+    MAX_DETAILS_BYTES = 8192
     MESSAGE_TRUNCATION_SUFFIX = "…[truncated]".freeze
 
     EM_DASH = "—".freeze
@@ -46,7 +50,19 @@ module Hive
     # appenders via the inode lock; we cap message size (see
     # MAX_MESSAGE_BYTES) so the full line stays small and well-defined.
     # status.md is derived state and is rewritten with atomic rename.
-    def emit(task_folder:, slug:, stage:, event_type:, agent: nil, message: nil)
+    def emit(**kwargs)
+      emit_required(**kwargs)
+    rescue SystemCallError, IOError => e
+      warn "[hive.events] failed to emit #{kwargs[:event_type]} for #{kwargs[:task_folder]}: " \
+           "#{e.class}: #{e.message}"
+      nil
+    end
+
+    # Required variant for state transitions whose correctness depends on a
+    # durable event (retry reservations and manual retry-history resets).
+    # Append failures propagate to the caller. status.md is derived state, so
+    # a render failure is warned but does not invalidate an appended event.
+    def emit_required(task_folder:, slug:, stage:, event_type:, agent: nil, message: nil, details: nil)
       event_type = event_type.to_sym
       unless EVENT_TYPES.include?(event_type)
         raise ArgumentError, "unknown event_type #{event_type.inspect}; valid: #{EVENT_TYPES.inspect}"
@@ -60,6 +76,7 @@ module Hive
         "event_type" => event_type.to_s,
         "message" => message.nil? ? nil : truncate_message(message.to_s)
       }
+      record["details"] = normalize_details(details) unless details.nil?
 
       FileUtils.mkdir_p(task_folder)
       events_path = File.join(task_folder, "events.jsonl")
@@ -70,11 +87,30 @@ module Hive
       File.open(events_path, File::WRONLY | File::APPEND | File::CREAT, 0o644, encoding: "UTF-8") do |file|
         file.syswrite(line)
       end
-      render_status!(task_folder, record)
+      begin
+        render_status!(task_folder, record)
+      rescue SystemCallError, IOError => e
+        warn "[hive.events] failed to render status for #{task_folder}: #{e.class}: #{e.message}"
+      end
       record
-    rescue SystemCallError => e
-      warn "[hive.events] failed to emit #{event_type} for #{task_folder}: #{e.class}: #{e.message}"
-      nil
+    end
+
+    def normalize_details(details)
+      unless details.is_a?(Hash)
+        raise ArgumentError, "event details must be a Hash; got #{details.class}"
+      end
+
+      normalized = JSON.parse(JSON.generate(details))
+      unless normalized.is_a?(Hash)
+        raise ArgumentError, "event details must encode as a JSON object"
+      end
+      if JSON.generate(normalized).bytesize > MAX_DETAILS_BYTES
+        raise ArgumentError, "event details exceed #{MAX_DETAILS_BYTES} bytes"
+      end
+
+      normalized
+    rescue JSON::GeneratorError, TypeError => e
+      raise ArgumentError, "event details must contain only JSON values: #{e.message}"
     end
 
     def truncate_message(message)
diff --git a/lib/hive/invoked_binary.rb b/lib/hive/invoked_binary.rb
index 54eea962..ff3c9a4e 100644
--- a/lib/hive/invoked_binary.rb
+++ b/lib/hive/invoked_binary.rb
@@ -1,3 +1,6 @@
+require "digest"
+require "json"
+
 module Hive
   # Resolves the user-facing CLI path to bake into the systemd-user /
   # launchd daemon unit. Precedence:
@@ -14,6 +17,7 @@ module Hive
   module InvokedBinary
     ENV_KEY = "HIVE_INVOKED_BIN".freeze
     VALID_NAMES = %w[hive hv].freeze
+    IDENTITY_MUTEX = Mutex.new
 
     module_function
 
@@ -46,5 +50,52 @@ module Hive
 
       nil
     end
+
+    # Capture the identity of the Hive source tree represented by this
+    # process. The manifest covers every Ruby file under lib/hive, not only
+    # hive.rb, so an in-place same-version update of a loaded component
+    # changes the identity seen by a newly started CLI.
+    def capture_loaded_identity(source: nil)
+      source ||= Hive.const_source_location(:VERSION)&.first
+      source = File.expand_path("../hive.rb", __dir__) if source.to_s.empty?
+      real_source = File.realpath(source)
+      root = File.expand_path("..", File.dirname(real_source))
+      lib_root = File.dirname(real_source)
+      files = [ real_source ] + Dir.glob(File.join(lib_root, "hive", "**", "*.rb"))
+      digest = ::Digest::SHA256.new
+      files.map { |path| File.realpath(path) }.uniq.sort.each do |path|
+        digest.update(path.delete_prefix("#{root}#{File::SEPARATOR}"))
+        digest.update("\0")
+        digest.update(File.binread(path))
+        digest.update("\0")
+      end
+      source_digest = digest.hexdigest
+      {
+        "version" => Hive::VERSION,
+        "install_root" => root,
+        "source_digest" => source_digest,
+        "fingerprint" => ::Digest::SHA256.hexdigest(
+          JSON.generate([ Hive::VERSION, root, source_digest ])
+        )
+      }
+    rescue SystemCallError
+      {
+        "version" => Hive::VERSION,
+        "install_root" => nil,
+        "source_digest" => nil,
+        "fingerprint" => nil
+      }
+    end
+
+    def loaded_identity
+      identity = @loaded_identity
+      unless identity
+        IDENTITY_MUTEX.synchronize do
+          @loaded_identity ||= capture_loaded_identity.freeze
+          identity = @loaded_identity
+        end
+      end
+      identity.dup
+    end
   end
 end
diff --git a/lib/hive/markers.rb b/lib/hive/markers.rb
index a97b3c47..10692294 100644
--- a/lib/hive/markers.rb
+++ b/lib/hive/markers.rb
@@ -98,6 +98,9 @@ module Hive
       new_marker
     end
 
+    # When a block is supplied, run it after removal while retaining the
+    # marker lock. A raised side-effect restores the original state-file body
+    # before propagating, for transitions whose audit is required.
     def clear_current(state_file_path, expected_name:, match_attrs: {})
       with_markers_lock(state_file_path) do
         marker = current(state_file_path)
@@ -106,7 +109,16 @@ module Hive
         expected = match_attrs.to_h.transform_keys(&:to_s)
         return false unless expected.all? { |key, value| marker.attrs[key].to_s == value.to_s }
 
+        original_body = File.binread(state_file_path)
         remove_marker(state_file_path, marker.raw)
+        if block_given?
+          begin
+            yield marker
+          rescue StandardError
+            write_atomic(state_file_path, original_body)
+            raise
+          end
+        end
         true
       end
     end
diff --git a/lib/hive/stages/base.rb b/lib/hive/stages/base.rb
index 979b4800..cd1b2952 100644
--- a/lib/hive/stages/base.rb
+++ b/lib/hive/stages/base.rb
@@ -633,6 +633,7 @@ module Hive
         warn "[hive] claude launch failed: #{e.message}"
         Hive::Markers.set(task.state_file, :error,
                           reason: "claude_launch_failed",
+                          writer: "stages_base_claude_launcher",
                           exception_class: e.class.name,
                           message: e.message)
         { status: :error, error_message: e.message }
diff --git a/lib/hive/stages/execute.rb b/lib/hive/stages/execute.rb
index c3081b89..a05ddaa7 100644
--- a/lib/hive/stages/execute.rb
+++ b/lib/hive/stages/execute.rb
@@ -215,6 +215,8 @@ module Hive
 
         Hive::Markers.set(task.state_file, :error,
                           reason: "implementer_failed",
+                          agent: execute_agent_name(cfg),
+                          log_file: implementation_log_basename(impl_result),
                           status: impl_result&.fetch(:status, nil),
                           message: impl_result&.fetch(:error_message, nil))
         { commit: "implementer_failed", status: :error }
@@ -233,6 +235,13 @@ module Hive
         nil
       end
 
+      def implementation_log_basename(impl_result)
+        path = impl_result&.fetch(:log_file, nil).to_s
+        return nil if path.empty?
+
+        File.basename(path)
+      end
+
       def spawn_implementation(task, cfg, worktree_path)
         plan_text = File.read(File.join(task.folder, "plan.md"))
         prompt = Hive::Stages::Base.render(
diff --git a/test/integration/cli_version_test.rb b/test/integration/cli_version_test.rb
index e390718e..76d60bec 100644
--- a/test/integration/cli_version_test.rb
+++ b/test/integration/cli_version_test.rb
@@ -14,6 +14,14 @@ class CliVersionTest < Minitest::Test
     assert_equal "#{Hive::VERSION}\n", out
   end
 
+  def test_install_fingerprint_matches_loaded_identity
+    payload = JSON.parse(
+      run!(RbConfig.ruby, "-Ilib", "bin/hive", "--install-fingerprint")
+    )
+
+    assert_equal Hive::InvokedBinary.loaded_identity, payload
+  end
+
   def test_bin_hive_help_after_option_value_shows_command_usage
     out, err, status = Open3.capture3(
       RbConfig.ruby, "-Ilib", "bin/hive", "approve", "--from", "2-brainstorm", "--help"
diff --git a/test/integration/daemon_auto_retry_test.rb b/test/integration/daemon_auto_retry_test.rb
new file mode 100644
index 00000000..5b6ef9fa
--- /dev/null
+++ b/test/integration/daemon_auto_retry_test.rb
@@ -0,0 +1,391 @@
+require "test_helper"
+require "shellwords"
+require "yaml"
+require "hive/config"
+require "hive/daemon/auto_retry"
+require "hive/daemon/auto_retry_history"
+require "hive/daemon/auto_retry_policy"
+require "hive/daemon/auto_retry_probe"
+require "hive/daemon/concurrency_controller"
+require "hive/daemon/dispatcher"
+require "hive/daemon/dispatch_request_queue"
+require "hive/daemon/status_consumer"
+require "hive/invoked_binary"
+require "hive/task_meta"
+
+class DaemonAutoRetryIntegrationTest < Minitest::Test
+  include HiveTestHelper
+
+  HealthyDoctor = Struct.new(:unused) do
+    def required_checks
+      { healthy: true, rows: [] }
+    end
+  end
+
+  class RecordingSupervisor
+    attr_reader :spawned
+
+    def initialize
+      @spawned = []
+      @next_pid = 100
+    end
+
+    def spawn(**attrs)
+      pid = @next_pid
+      @next_pid += 1
+      @spawned << attrs.merge(pid: pid)
+      pid
+    end
+
+    def reap_all(now: Time.now)
+      []
+    end
+
+    def reap_dry_run(now: Time.now)
+      []
+    end
+
+    def enforce_timeouts(now:)
+      []
+    end
+
+    def terminate_all(grace_sec: 600); end
+
+    def update_timeouts(default_timeout_sec:, verb_timeouts:, kill_grace_sec:); end
+
+    def in_flight_count
+      @spawned.length
+    end
+  end
+
+  class RecordingLogger
+    attr_reader :events
+
+    def initialize
+      @events = []
+    end
+
+    def event(name, **attrs)
+      @events << [ name, attrs ]
+    end
+  end
+
+  def test_dispatcher_keeps_crash_seam_request_parked_until_codex_recovers
+    with_tmp_dir do |root|
+      fixture = build_execute_fixture(root)
+      login_flag = File.join(root, "codex-logged-in")
+      codex = write_executable(File.join(root, "bin", "codex"), <<~SH)
+        #!/bin/sh
+        if [ "$1" = "login" ]; then
+          test -f #{Shellwords.escape(login_flag)}
+          exit $?
+        fi
+        if [ "$1" = "exec" ]; then
+          printf '{"type":"result","result":"OK"}\\n'
+          exit 0
+        fi
+        exit 2
+      SH
+      hive, status_calls = write_status_hive(root, fixture)
+      seed_crash_seam_request(fixture)
+      dispatcher, supervisor, logger = build_dispatcher(
+        fixture,
+        hive_bin: hive,
+        env: ENV.to_h.merge("HIVE_CODEX_BIN" => codex)
+      )
+
+      with_registered_project(fixture) do
+        dispatcher.tick(now: fixture[:now])
+
+        assert_equal 1, File.readlines(status_calls).length
+        assert_empty supervisor.spawned
+        assert_equal :error, Hive::Markers.current(fixture[:state_file]).name
+        assert_equal 1, pending_requests(fixture).length
+        blocked = logger.events.find { |name, _attrs| name == :dispatch_request_blocked }
+        assert_equal "marker_not_cleared", blocked.last[:reason]
+
+        File.write(login_flag, "healthy\n")
+        dispatcher.tick(now: fixture[:now] + 600)
+      end
+
+      assert_equal 2, File.readlines(status_calls).length
+      assert_equal :none, Hive::Markers.current(fixture[:state_file]).name
+      assert_empty pending_requests(fixture)
+      assert_equal 1, supervisor.spawned.length
+      assert_equal(
+        "hive run retry-task --project demo --stage 4-execute",
+        supervisor.spawned.first.fetch(:command_string)
+      )
+      cleared = read_events(fixture[:folder]).find do |event|
+        event["event_type"] == "marker_cleared"
+      end
+      assert_equal "crash-marker", cleared.dig("details", "marker_id")
+    end
+  end
+
+  def test_dispatcher_runs_full_claude_probe_chain_and_dispatches_guarded_request
+    with_tmp_dir do |root|
+      fixture = build_brainstorm_fixture(root)
+      claude = write_executable(File.join(root, "bin", "claude"), <<~SH)
+        #!/bin/sh
+        echo 'Claude 2.1.999'
+      SH
+      hive, status_calls = write_status_hive(root, fixture, include_identity: true)
+      dispatcher, supervisor, _logger = build_dispatcher(
+        fixture,
+        hive_bin: hive,
+        env: ENV.to_h.merge("HIVE_CLAUDE_BIN" => claude)
+      )
+
+      with_registered_project(fixture) do
+        dispatcher.tick(now: fixture[:now])
+      end
+
+      assert_equal 1, File.readlines(status_calls).length
+      assert_equal :none, Hive::Markers.current(fixture[:state_file]).name
+      assert_empty pending_requests(fixture)
+      assert_equal 1, supervisor.spawned.length
+      reservation = read_events(fixture[:folder]).find do |event|
+        event["event_type"] == "auto_retry_reserved"
+      end
+      assert_equal 17, reservation.dig("details", "task_id")
+      assert_equal 1, reservation.dig("details", "attempt")
+      assert_equal 5, reservation.dig("details", "probes").length
+    end
+  end
+
+  private
+
+  def build_dispatcher(fixture, hive_bin:, env:)
+    config = Hive::Config.load(fixture[:project])
+    auto_retry = Hive::Daemon::AutoRetry.new(
+      policy: Hive::Daemon::AutoRetryPolicy.new,
+      probe_factory: lambda { |_row, _decision|
+        Hive::Daemon::AutoRetryProbe.new(
+          config: config,
+          project_root: fixture[:project],
+          hive_bin: hive_bin,
+          env: env,
+          doctor_factory: -> { HealthyDoctor.new }
+        )
+      },
+      state_home: fixture[:state_home]
+    )
+    controller = Hive::Daemon::ConcurrencyController.new(
+      max_concurrent_runs: 5,
+      max_concurrent_per_project: 5,
+      max_runs_per_day_per_project: 100
+    )
+    supervisor = RecordingSupervisor.new
+    logger = RecordingLogger.new
+    dispatcher = Hive::Daemon::Dispatcher.new(
+      config: config,
+      controller: controller,
+      supervisor: supervisor,
+      status_consumer: Hive::Daemon::StatusConsumer.new(hive_bin: hive_bin),
+      logger: logger,
+      dispatch_request_state_home: fixture[:state_home],
+      dispatch_result_state_home: fixture[:state_home],
+      auto_retry: auto_retry
+    )
+    [ dispatcher, supervisor, logger ]
+  end
+
+  def build_execute_fixture(root)
+    fixture = base_fixture(root, stage: "4-execute", state_name: "task.md")
+    worktree = File.join(root, "worktrees", "retry-task")
+    FileUtils.mkdir_p(File.dirname(worktree))
+    run!("git", "-C", fixture[:project], "worktree", "add", "--quiet",
+         "-b", "retry-task", worktree)
+    File.write(
+      File.join(fixture[:folder], "worktree.yml"),
+      { "path" => worktree }.to_yaml
+    )
+
+    auth = "request failed with 401: Missing bearer or basic authentication in header"
+    log_dir = File.join(fixture[:project], ".hive-state", "logs", fixture[:slug])
+    FileUtils.mkdir_p(log_dir)
+    log_name = "execute-impl-current.log"
+    log_file = File.join(log_dir, log_name)
+    File.write(log_file, auth)
+    attrs = {
+      "reason" => "implementer_failed",
+      "marker_id" => "crash-marker",
+      "agent" => "codex",
+      "log_file" => log_name,
+      "status" => "error",
+      "message" => "exit_code=1"
+    }
+    Hive::Markers.set(fixture[:state_file], :error, attrs)
+    fixture[:attrs] = attrs
+    fixture[:log_file] = log_file
+    fixture
+  end
+
+  def build_brainstorm_fixture(root)
+    fixture = base_fixture(root, stage: "2-brainstorm", state_name: "brainstorm.md")
+    attrs = {
+      "reason" => "claude_launch_failed",
+      "marker_id" => "claude-marker",
+      "writer" => Hive::Daemon::AutoRetryPolicy::CLAUDE_MARKER_WRITER,
+      "exception_class" => "Hive::AgentError",
+      "message" => "Claude launcher failed before readiness"
+    }
+    Hive::Markers.set(fixture[:state_file], :error, attrs)
+    fixture[:attrs] = attrs
+    fixture
+  end
+
+  def base_fixture(root, stage:, state_name:)
+    project = File.join(root, "demo")
+    FileUtils.mkdir_p(project)
+    run!("git", "-C", project, "init", "-b", "main", "--quiet")
+    run!("git", "-C", project, "config", "user.email", "test@example.com")
+    run!("git", "-C", project, "config", "user.name", "Test")
+    File.write(File.join(project, "README.md"), "fixture\n")
+    run!("git", "-C", project, "add", "README.md")
+    run!("git", "-C", project, "commit", "-m", "fixture", "--quiet")
+    folder = File.join(project, ".hive-state", "stages", stage, "retry-task")
+    FileUtils.mkdir_p(folder)
+    File.write(
+      File.join(project, ".hive-state", "config.yml"),
+      {
+        "daemon" => {
+          "enabled" => true,
+          "auto_retry" => { "enabled" => true }
+        },
+        "execute" => { "agent" => "codex" },
+        "worktree_root" => File.join(root, "worktrees")
+      }.to_yaml
+    )
+    Hive::TaskMeta.write(
+      folder,
+      id: 17,
+      slug: "retry-task",
+      display_name: "Retry task"
+    )
+    {
+      project: project,
+      hive_state: File.join(project, ".hive-state"),
+      folder: folder,
+      state_file: File.join(folder, state_name),
+      state_home: File.join(root, "state-home"),
+      project_name: "demo",
+      slug: "retry-task",
+      stage: stage,
+      now: Time.utc(2026, 7, 24, 12)
+    }
+  end
+
+  def seed_crash_seam_request(fixture)
+    Hive::Daemon::AutoRetryHistory.new.reserve!(
+      task_folder: fixture[:folder],
+      task_id: 17,
+      slug: fixture[:slug],
+      stage: fixture[:stage],
+      marker_id: fixture[:attrs].fetch("marker_id"),
+      reason: fixture[:attrs].fetch("reason"),
+      fingerprint: "health-before-crash",
+      attempt: 1,
+      probes: [],
+      now: fixture[:now] - 1
+    )
+    anchor = Time.now
+    FileUtils.touch(fixture[:log_file], mtime: anchor - 120)
+    FileUtils.touch(fixture[:state_file], mtime: anchor - 60)
+    FileUtils.touch(
+      File.join(fixture[:folder], "status.md"),
+      mtime: anchor + 60
+    )
+    Hive::Daemon::DispatchRequestQueue.write_request!(
+      project: fixture[:project_name],
+      slug: fixture[:slug],
+      argv: [
+        "hive", "run", fixture[:slug], "--project", fixture[:project_name],
+        "--stage", fixture[:stage]
+      ],
+      requestor: "healer",
+      trigger: "recoverable_dependency_failure",
+      expected_cleared_marker_id: fixture[:attrs].fetch("marker_id"),
+      state_home: fixture[:state_home],
+      now: fixture[:now]
+    )
+  end
+
+  def write_status_hive(root, fixture, include_identity: false)
+    status_path = File.join(root, "status.json")
+    calls_path = File.join(root, "status-calls.log")
+    File.write(status_path, JSON.generate(status_payload(fixture)))
+    identity = include_identity ? JSON.generate(Hive::InvokedBinary.loaded_identity) : "{}"
+    hive = write_executable(File.join(root, "bin", "hive"), <<~SH)
+      #!/bin/sh
+      if [ "$1" = "status" ]; then
+        printf 'status\\n' >> #{Shellwords.escape(calls_path)}
+        exec cat #{Shellwords.escape(status_path)}
+      fi
+      if [ "$1" = "--install-fingerprint" ]; then
+        printf '%s\\n' '#{identity}'
+        exit 0
+      fi
+      exit 2
+    SH
+    [ hive, calls_path ]
+  end
+
+  def status_payload(fixture)
+    {
+      "schema" => "hive-status",
+      "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-status"),
+      "ok" => true,
+      "projects" => [
+        {
+          "name" => fixture[:project_name],
+          "legacy_stage_dirs" => [],
+          "tasks" => [
+            {
+              "id" => 17,
+              "slug" => fixture[:slug],
+              "stage" => fixture[:stage],
+              "marker" => "error",
+              "attrs" => fixture[:attrs],
+              "folder" => fixture[:folder],
+              "state_file" => fixture[:state_file],
+              "action" => "error",
+              "blocked" => false
+            }
+          ]
+        }
+      ]
+    }
+  end
+
+  def with_registered_project(fixture, &block)
+    entry = {
+      "name" => fixture[:project_name],
+      "path" => fixture[:project],
+      "hive_state_path" => fixture[:hive_state]
+    }
+    with_replaced_singleton_method(
+      Hive::Config, :find_project,
+      ->(name) { name == fixture[:project_name] ? entry : nil },
+      &block
+    )
+  end
+
+  def pending_requests(fixture)
+    Hive::Daemon::DispatchRequestQueue.pending(state_home: fixture[:state_home])
+  end
+
+  def write_executable(path, content)
+    FileUtils.mkdir_p(File.dirname(path))
+    File.write(path, content)
+    File.chmod(0o755, path)
+    path
+  end
+
+  def read_events(folder)
+    File.readlines(File.join(folder, "events.jsonl"), chomp: true).map do |line|
+      JSON.parse(line)
+    end
+  end
+end
diff --git a/test/integration/daemon_command_test.rb b/test/integration/daemon_command_test.rb
index a3c43fef..b371763c 100644
--- a/test/integration/daemon_command_test.rb
+++ b/test/integration/daemon_command_test.rb
@@ -3,6 +3,7 @@ require "json"
 require "open3"
 require "tmpdir"
 require "rbconfig"
+require "hive/daemon/dispatch_request_queue"
 
 # Integration test for `hive daemon` subcommands. Uses real bin/hive
 # subprocesses against a temporary HIVE_HOME so PID file / log file
diff --git a/test/integration/markers_command_test.rb b/test/integration/markers_command_test.rb
index 19e14bfe..8aa68ff0 100644
--- a/test/integration/markers_command_test.rb
+++ b/test/integration/markers_command_test.rb
@@ -206,6 +206,62 @@ class MarkersCommandTest < Minitest::Test
     end
   end
 
+  def test_successful_manual_error_clear_records_reset_identity
+    with_tmp_global_config do
+      with_tmp_git_repo do |dir|
+        _, folder, _slug = seed_review_task(dir, marker: :error)
+        state = File.join(folder, "task.md")
+        Hive::Markers.set(state, :error, reason: "implementer_failed", marker_id: "current-marker")
+
+        capture_io do
+          Hive::Commands::Markers.new(
+            "clear", folder, name: "ERROR", match_attr: "marker_id=current-marker"
+          ).call
+        end
+
+        event = File.readlines(File.join(folder, "events.jsonl"), chomp: true)
+                    .map { |line| JSON.parse(line) }
+                    .find { |row| row["event_type"] == "marker_cleared" }
+        assert_equal "manual", event.dig("details", "actor")
+        assert_equal "current-marker", event.dig("details", "marker_id")
+        assert_equal "implementer_failed", event.dig("details", "marker_reason")
+      end
+    end
+  end
+
+  def test_manual_clear_restores_marker_when_required_reset_event_cannot_append
+    with_tmp_global_config do
+      with_tmp_git_repo do |dir|
+        _, folder, _slug = seed_review_task(dir, marker: :error)
+        state = File.join(folder, "task.md")
+        Hive::Markers.set(
+          state, :error,
+          reason: "implementer_failed", marker_id: "current-marker"
+        )
+        original = File.binread(state)
+
+        with_replaced_singleton_method(
+          Hive::Events, :emit_required,
+          ->(**) { raise Errno::ENOSPC, "events.jsonl" }
+        ) do
+          assert_raises(Hive::InternalError) do
+            capture_io do
+              Hive::Commands::Markers.new(
+                "clear", folder, name: "ERROR",
+                match_attr: "marker_id=current-marker"
+              ).call
+            end
+          end
+        end
+
+        assert_equal original, File.binread(state)
+        marker = Hive::Markers.current(state)
+        assert_equal :error, marker.name
+        assert_equal "current-marker", marker.attrs["marker_id"]
+      end
+    end
+  end
+
   # ── Allowlist enforcement ──────────────────────────────────────────────
 
   def test_rejects_unknown_marker_name
diff --git a/test/unit/bot/brainstorm_parser_test.rb b/test/unit/bot/brainstorm_parser_test.rb
index 3f342cbd..16617f79 100644
--- a/test/unit/bot/brainstorm_parser_test.rb
+++ b/test/unit/bot/brainstorm_parser_test.rb
@@ -287,4 +287,17 @@ class HiveBotBrainstormParserTest < Minitest::Test
     assert_nil questions[0].answer, "Q1 with no A line must stay unanswered"
     assert_equal "yes", questions[1].answer
   end
+
+  def test_answered_questions_returns_only_user_completed_slots
+    questions = Hive::Bot::BrainstormParser.parse_text(<<~MARKDOWN)
+      ## Round 1
+      ### Q1. First?
+      ### A1.
+      yes
+      ### Q2. Second?
+      ### A2.
+    MARKDOWN
+
+    assert_equal [ 1 ], Hive::Bot::BrainstormParser.answered_questions(questions).map(&:n)
+  end
 end
diff --git a/test/unit/claude_launcher_test.rb b/test/unit/claude_launcher_test.rb
index cb83b392..e98b90a1 100644
--- a/test/unit/claude_launcher_test.rb
+++ b/test/unit/claude_launcher_test.rb
@@ -1600,4 +1600,10 @@ class ClaudeLauncherTest < Minitest::Test
     assert_match(/example-task/, err)
     assert_match(/cleanup/, err)
   end
+
+  def test_readiness_self_check_uses_production_detector
+    assert Hive::ClaudeLauncher.readiness_self_check
+    assert_equal File.expand_path("../../lib/hive/scripts/interactive_claude_wrapper.sh", __dir__),
+                 Hive::ClaudeLauncher.interactive_wrapper_path
+  end
 end
